/* sqw-bsy.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Subroutines for correct creation   ணࠬ ४⭮ ᮧ   -
 * and deleting .bsy files.           ࠭ 䠩 .bsy.
 *
 * Assumes, that we need  only  ONE   ࠧ㬥,     ६-
 * such file every time. It is eno-     㦥 ஢  ⠪ 䠩. ⮣
 * ugh for tosser.                    筮  .
 *
 * DO NOT use this routines in mul-    ᯮ  ணࠬ  -
 * tiline mailer's! They are  simp-      
 * lified to tosser task, and using
 * fixed name for temporary files.
 *
 * bsy_create():
 *
 * returns handle number if successful        祭   ᯥ
 * returns -1 if not success (check errno)   -1  ᯥ (. errno):
 * errno = 0 - not our bsy file exists.      errno = 0 - 㦥    bsy
 * errno = EPERM  - no correct method on fs   ४⭮ ⮤  ⮩ fs
 * other - as open() and link() errno values ⠫쭮 -  open / link.
 *
 * bsy_remove():
 *
 * returns 0 if successful                   0  ᯥ
 * returns -1 if close returns -1           -1  close.
 *
 */

#if (!defined(UNIX))
#define flock(A,B)
#define link(A,B) rename(A,B)
#else
#include <sys/file.h>
#endif

int bsy_create(char *, char *);
int bsy_remove(void);

static char *s0 = NULL;				/* Path to setted .bsy	*/
static int  handle = -1;			/* flocked file handle	*/

int bsy_remove()
{
int newhandle;
errno = EINVAL;
if ((s0 != NULL) && (handle != -1))
	{
	errno = 0;
#if (defined(__TURBOC__))
	chmod(s0, S_IFREG | S_IWRITE);
#endif
	unlink(s0);				/* delete file		*/
	free(s0);				/* free allocated path	*/
	s0 = NULL;				/* path initialize	*/
	flock(handle, LOCK_UN);			/* unlocking handle	*/
	newhandle = close(handle);		/* close handle		*/
	handle = -1;				/* handle initialize	*/
	return newhandle;			/* return close result	*/
	}
else	return -1;
}

int bsy_create(char *path, char *ext)
{
char *s1, *s2 = path;				/* pointers for copying	*/
struct stat f1;					/* for stat functions	*/
#ifdef UNIX
struct stat f2;
#endif
int errnow = 0;					/* temporary ints	*/

errno = 0;
if ((path == NULL) || (ext == NULL)) return -1;

handle = open(path, O_CREAT | SQW_O_EXCL);	/* creation tmp file 	*/
if (handle == -1) return -1; else;		/* not success		*/

flock(handle, LOCK_EX);				/* opened file locked	*/

s1 = s0 = farmalloc(strlen(path) + strlen(ext) + 3);
if (s0 == NULL)					/* not allocated path	*/
   {
   close(handle);
   handle = -1;
   unlink(path);
   errno = ENOMEM;
   return -1;
   }
else;

while (*s2) *s1++ = *s2++;			/* assemble s0 from	*/
while (*ext)  *s1++ = *ext++;			/* path + ext		*/
*s1 = '\0';					/* finish line		*/
errno = 0;
if(link(path, s0))				/* attempt to link	*/
     {						/* not success		*/
     if (errno == EEXIST) errnow = 0;		/* already here		*/
     else errnow = errno;			/* other errors		*/
     goto Not_Our_Bsy_Ending;
     }
else {
#ifdef UNIX
/*
 * Correct UNIX checking - only  by   ४⭠ ஢ઠ  UNIX - ⮫쪮 -
 * equivalence of inodes of  linked   ⭮ inod' ᫨ 䠩
 * files.                              ⥫⢮!
 *
 * Any other method isn't enough!      㣮 ⮤   墠!
 * 
 * Returned  values of  link()  are   頥 㭪樥 link() 祭 
 * not fully  documented to guaran-   ⮫쪮  㬥஢,  ⮡
 * tee other checking results.        ࠭஢ १  ஢ન.
 *
 */

     if ((!stat(path,&f1)) && (!stat(s0, &f2)))	/* Success .bsy created */
     if (f1.st_ino == f2.st_ino)		/*    !	*/
	{
	unlink(path);				/* Clear old link	*/
	return handle;				/* Return Success	*/
	}
     else /* f1.st_inode == f2.st_inode */	/* Non-success attempt	*/
	{					/*   㦠    */
	errnow = 0;
	goto Not_Our_Bsy_Ending;
	}
#else
/*
 * Non-UNIX version - rename() che-     UNIX'  ᥣ ஢ -
 * cking  plus  checking  existance    rename()  ஢ 稥 䠩-
 * of result file is the best way.    ,    २.
 *
 */
     if (stat(path,&f1))
     	return handle;			/* success renaming!	*/
     else errnow = 0;
#endif
     } /* else if (link) */

Not_Our_Bsy_Ending:

flock(handle, LOCK_UN);		/* ࠧ ਯ 䠩   */
close(handle);			/*  			*/
unlink(path);			/*  ஬ 䠩   */
free(s0);			/* ᢮   	*/
handle = -1;
s0 = NULL;
errno = errnow;			/* restore right errno value	*/
return handle;
} /* bsy_create() */
/* EOF sqw-bsy.c */
