/* sqw-bt.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Bink-Style OutBound parsing, bat     Bink-Outbound, 뢠  -
 * or script packing file writing.     䠩 㯠.
 *
 * Generation  netmail comment mes-    -ਥ   .~NM  
 * sages to .~NM files in outbound.   ⡠㭤.
 *
 */

#include "sqw-inc.h"

void Sqw_comment(int, int, unsigned int);
void Sqw_notice(int, char *);
void Sqw_bt(unsigned int, unsigned int, int, unsigned int);

/* ========================================================================= */

/* Number of seconds in full day     ᫮ ᥪ㭤  ⪠		     */
#define SUTKI 86400L

/*======================= ࠡ⪠ -⠩ ⡠㭤 ====================
what_to_do == 0:

- if area == AREAKIL -  echosaw  by    area == AREAKIL ࠡ⠥  宯  
Link[link].holdTime days and  kills   .holdTime   㡨  㭪-
old truncated arcmails if TruncWeek.   બ ᫨ TruncWeek.

- Analysing HoldPath, where arcmail    ४਩ HoldPath,  ᪫-
files are placed.                      બ   .

- Finds arcmail for the .OUT packet    室饣 બ  ⮣, -
to be packed in.                           .OUT

- If areanumber needs Comment  mes-   ᫨   ""  ॡ  樨
sage to be generated - calls  func-   饣 ᮮ饭 - 뢠
tion Sqw_Comment().                   㭪 Sqw_Comment().

- If echosaw  deletes  arcmail  and   ᫨ 宯 ࠥ બ,   ࠬ
ForwardBad  parameter is setted for   ForwardBad   ⠭ - 뢠-
this link - Sqw_notice is called.      Sqw_notice().
-----------------------------------------------------------------------------*/
static int arorigin;			/*   ᮪饭 	     */
static int  i;				/* 稪  ᥣ 	     */
static long days;			/*  ⭮ બ     */
static struct stat  statbuf;		/*   fstat		     */
static char arcext[4];			/* ७ 䠩 બ	     */
static char too_old[] = ": too old - deleted";
time_t ttu;

void Sqw_bt(unsigned int area, unsigned int link, int what_to_do,
		unsigned int msgnum)
{
arorigin = Area[area].Org;
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
if (area == AREAKIL) strcpy(arcext, "???"); /* ᫨ 宯 -  ᪠   */
else if (Link[link].OutMin != 0L)	    /* ᫨     -    */
	{
	Link[link].OutMax = ttt;	    /* ᬥ  ᫥     */
	arcext[0] = Link[link].OutExt[0];   /*  ७ બ     */
	arcext[1] = Link[link].OutExt[1];
	arcext[2] = Link[link].OutExt[2];
	arcext[3] = '\0';
	}
     else {					/* ᫨    - */
     						/* ନ஢ ७ */
	  sprintf (arcext, "%.2s", ctime(&ttu));
	  if (Cfg_OutFileLowerCase)	arcext[0] = (char)tolower((int)arcext[0]);
	  else				arcext[1] = (char)toupper((int)arcext[1]);
	  arcext[2] = '0';
	  arcext[3] = '\0';
	  }

/*
 * Correct work with  Domains  will   ४⭠ ࠡ   㤥 ᤥ-
 * be implemented later.               .
 */


if (!Cfg_ArcMailAttach)
  {
  if (Link[link].Zone != My[0].Zone)	/*    ᫨     */
	{				/* ᮢ  ஬  -    */
					/*  			     */
	sprintf ((char *)BinkPath + BinkLen - 1,  formatZone,
			Link[link].Zone, BACKSLASH);
	}
  else;
  DirCheck(BinkPath, strlen(BinkPath) - 1); /* ஢ -⠩    */

  if (Link[link].Point != 0)		/* ᫨    ᮪    */
     {					/* 				     */
     sprintf ((char *)BinkPath + strlen(BinkPath), formatNetNodePoint,
		Link[link].Net, Link[link].Node, BACKSLASH,
		Link[link].Point);
     DirCheck(BinkPath, strlen(BinkPath) - 9); /*  ᮧ ⠫	     */
     } /* if Link[link].Point != 0 */
  else	{				/*  㧫 		     */
	sprintf ((char *)BinkPath + strlen(BinkPath), formatNetNode,
		Link[link].Net, Link[link].Node);
	}
  } /* if !Cfg_ArcMailAttach */
else;

if (Link[link].Zone != My[0].Zone)
	sprintf ((char *)HoldPath + HoldLen - 1, formatZone,
			Link[link].Zone, BACKSLASH);
else;
DirCheck(HoldPath, strlen(HoldPath) - 1);

if (Link[link].Point != 0)
     {
     sprintf ((char *)HoldPath + strlen(HoldPath), formatARCNetNodePoint,
	Link[link].Net, Link[link].Node, BACKSLASH, '0',
	((Cfg_OutNames == 1) ? (Link[link].Point) 
			     : (-Link[link].Point)), arcext);
     DirCheck(HoldPath, strlen(HoldPath) - 13);
     }
else sprintf ((char *)HoldPath + strlen(HoldPath), formatARCNetNode,
	((Cfg_OutNames == 1) ? (Link[link].Net) : (My[arorigin].Net - Link[link].Net)),
	((Cfg_OutNames == 1) ? (Link[link].Node) : (My[arorigin].Node - Link[link].Node)),
	arcext);
/* - - - - - - EchoSaw module - - - - - - - - - - - - - - - - - - - - - - - -*/
if ((!what_to_do) && (area == AREAKIL))
   { struct ffblk ffbbk; char *s0 = HoldPath + strlen(HoldPath) - 1;
   *s0 = '?';
   while ((s0 > HoldPath) && (*s0 != BACKSLASH)) s0--;
   if (*s0 == BACKSLASH) s0++; else;	/* now s0 in the beginning of fname  */

   if (!findfirst((char *)HoldPath,&ffbbk, 0)) /* is here at least one file? */
     do	{					/* while !findnext()	     */
			/* Do Not touch .?lo and .?ut if they are here	     */
 	if ((!strcasecmp_match(ffbbk.ff_name,"*.?lo")) ||
	    (!strcasecmp_match(ffbbk.ff_name,"*.?ut"))) continue;
	else;
	strcpy(s0,ffbbk.ff_name);		/* analyse current file	     */
	days = ttt - Date_from_file((char *)HoldPath, &ffbbk);
	days /= SUTKI;
	if (
	    (Link[link].holdTime && (days > (long)Link[link].holdTime)) ||
	    ((Cfg_TruncWeek == 1) && (statbuf.st_size == 0) && (days > 6)) ||
	    ((Cfg_TruncWeek >= 2) && (statbuf.st_size == 0) && (days > Cfg_TruncWeek))
	   )
		{
		chmod((char *)HoldPath, SQW_RWFILE);
		remove((char *)HoldPath);
		fputs ((char *)HoldPath, stdout);
		puts (too_old);
		OutLog2(LEV_WARN, (char *)HoldPath, too_old);
		if (Link[link].FwdBad && statbuf.st_size)
			Sqw_notice(link, s0);
		else;
		} /* if days > ... */
	else;
	}
     while (!findnext(&ffbbk));
   goto end_of_Sqw_bt;
   } /* if area == AREAKIL */
else;

/* - - - - - - Look for available arcmail name - - - - - - - - - - - - - - - */
/*
 * If it is first packet  for  this   ᫨     ⮩ 宮,
 * link (.OutMin indicates), if  it   ᫨   宮, ᫨  
 * is echoarea, if link isn't zero,   㫥  ᫨ what_to_do == 0
 * if what_to_do == 0.
 */
if (link && (area >= AREA1ST) && (!what_to_do) && (Link[link].OutMin == 0L))
    { char *s0 = HoldPath + strlen(HoldPath) - 1;
    for (i = '0'; i <= (int)Zz; i++)
	{
	if ((i > '9') && (i < (int)Aa))			/* '9'++ = 'A' */
		i = (int)Aa; else;
	*s0 = (char)i;
	if (!stat((char *)HoldPath, &statbuf))
	   {
	   if (Cfg_ArcShield && (!(statbuf.st_mode & S_IWRITE))) continue;
	   else;
	   if (Link[link].arcSize && 
	       (
	        ((unsigned long)Link[link].arcSize*1024) < 
	        (unsigned long)(statbuf.st_size)
	       )
	      )
	      continue; else;
	   if (statbuf.st_size == 0) continue; else;
	   break;
	   }
	else break;
	} /* for i = '0' */
    if (i == (int)Zz) OutLog(LEV_WARN,"Warning! Z letter in arcmail numbering reached!");
    else;
    Link[link].OutExt[2] = *s0--;
    Link[link].OutExt[1] = *s0--;
    Link[link].OutExt[0] = *s0;
    Link[link].OutMin = ttt;
    Link[link].OutMax = ttt;
    } /* if link && area > AREA1ST && !what_to_do && .OutMin == 0 */
else;
/* - - - - - - For non-echo areas - - - - - - - - - - - - - - - - - - - - - */
if (area < AREA1ST)
	{
	i = '0';
	HoldPath[strlen(HoldPath)-1] = '0';
	sprintf(HoldPath + strlen(HoldPath)-LENEXT-1-8, formatOUTnameOUT,
		(unsigned long)ttt, Oo, (char *)Ext[area]+1);
	}
else;
/*
Debug("area = %u", area);
Debug("link = %u", link);
Debug("FwdBad = %u", Link[link].FwdBad);
*/

if ((area >= AREA1ST) || (Link[link].FwdBad))
   {
/* - - - ᠫ  ਯ 㫥 ࠬ    .OUT - - - - - - - - */
   fprintf (filebat, formatLineOUT,
   call_sqwarc, OutPath, (unsigned long)ttt);
   if (Link[link].localPath)
	{ /* ᠫ ⮪ ப */
	if (area >= AREA1ST)
	   fprintf (filebat, formatLinePKT,
	    Link[link].localPath, (unsigned long)ttt);
	else
	   fprintf (filebat, formatLineOXX,
	    Link[link].localPath, (unsigned long)ttt,
	    (char *)Ext[area] + 1,
	    (char *)Ext[area] + 1);
	}
   else	{ /* .localPath */
	if (Cfg_ArcMailAttach)
	   {
   /* - - ᠫ ,   બ, T  K   - - - - - */
	   fprintf (filebat, "%hu:%hu/%hu.%hu %s %c %s\n",
			Link[link].Zone, Link[link].Net,
			Link[link].Node, Link[link].Point,
			HoldPath, ((Cfg_TruncSent) ? Tt : Kk),
			Link[link].Packer);
	   }
	else /* Cfg_ArcMailAttach */
	   {
	   fprintf (filebat, "%s %s %c %s\n",
		 BinkPath, HoldPath,
		((Cfg_OutFileLowerCase) ?
		 ((Cfg_TruncSent) ? 'd' : 'g') :
		 ((Cfg_TruncSent) ? '#' : '^')),
		 Link[link].Packer);
	   if (area < AREA1ST)
	   	Sqw_comment(link, area, msgnum);
	   else;
	   } /* else Cfg_ArcMailAttach */
	} /* else .localPath */
   } /* if area >= AREA1ST || FwdBad */

end_of_Sqw_bt:

HoldPath[HoldLen-1] = BACKSLASH; /*###034*/
BinkPath[BinkLen-1] = BACKSLASH; /*###034*/
HoldPath[HoldLen] = '\0';
BinkPath[BinkLen] = '\0';
} /* Sqw_bt() */

#if COMMENT_NOTICE_BAT

/*
 * Calls sqwarc.bat from sqwash.bat   뢠 sqwarc.bat    ⭮  䠩
 * with parameter C to create  mes-   sqwash.bat  ࠬ஬  C    ᮧ
 * sages by program sendmsg.exe.      ᮮ饭 ணࠬ sendmsg.exe.
 *
 */
/* - - - - - - - Notification about bad packets - - - - - - - - - - - - - - -*/
void Sqw_comment(int link, int area, unsigned int msgnum)
{
fprintf (filebat, 
	formatCommentLine,
	call_sqwarc, (unsigned long)ttt,
	Link[link].Zone, Link[link].Net,
	Link[link].Node, Link[link].Point,
	(char *)Ext[area]+1);
}/* Sqw_comment() */

/* - - - - - - - Notification about deleting echomail. - - - - - - - - - - - */
void Sqw_notice(int link, char *lline)
{
fprintf (filebat, 
		formatNoticeLine,
		call_sqwarc,lline,
		Link[link].Zone, Link[link].Net,
		Link[link].Node, Link[link].Point,
		(char *)Ext[AREAKIL]+1);
}/* Sqw_notice() */

#else /* COMMENT_NOTICE_BAT */
/*
 * Creates messages in .~NM files      ᮮ饭  .~NM 䠩 ᠬ-
 * instead of calling  sqwatc.bat     ⥫쭮,  ⮣, ⮡ 뢠 -
 * with C parameter.                   䠩 sqwarc.bat  ࠬ஬ C.
 */

static char *Body_msg[] = {
		"Error packet received from you!\r",
		"Arcmail packet deleted\n"};
static char tofrom[] = "SysOp\0SqWish\0";
static char subj[74];
static FILE *filein;
#if WHAT_BAD
static char prev_Lang[3] = {0,0,0};
#endif /* WHAT_BAD */
/* - - - - - - - Notification about bad packets - - - - - - - - - - - - - - -*
 *
 *
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

void Sqw_comment(int link, int area, unsigned int msgnum)
{
struct stat f;
char add_file_name[18];		/*  䠩 <>_<>.cfg            */
int  arorig = Area[area].Org;
size_t readen;

if (area == AREAFIX) sprintf(subj,"Remote request operation report");
else if (area != AREAKIL)
	{ char *s0;
	sprintf(subj,name8x_s_12s,
	  ttt++,Ext[area],		/*  㥬 䠩	     */
	  PKTFile[pktnum] + Inb_Len);	/*  PKT-譨		     */
	subj[9] = Oo;
	s0 = subj + strlen(subj)-LENEXT-1;
	if (s0[1] == 'K') *s0 = 'P'; else *s0 = 'p';
	}
     else;

if (area != AREAFIX)
 {
 if (Link[link].Zone != My[arorig].Zone)
  {
  for (arorig = 0; arorig < (int)My_Addr_Num; arorig++)
      if (My[arorig].Zone == Link[link].Zone) break;
  }
 else;
 if (arorig >= (int)My_Addr_Num) arorig = 0;	/* ᮢᥬ 㦠  - 䨣 */
 else;
 }
else arorig = Msg[msgnum].dMy;

pkt_netmail_begin(arorig);			/* ᣥ 砫    */
						/*  	     */
msg_netmail_begin(link, area);			/* ᣥ 砫 ᠣ  */
#if WHAT_BAD
if ((area == AREAPSE) || (area == AREABAD) ||
     (area == AREAPTH) || (area == AREASEC) || (area == AREABTL))
   {
   if ((Link[link].Lang[0] != prev_Lang[0]) ||
       (Link[link].Lang[1] != prev_Lang[1]) ||
       (Link[link].Lang[2] != prev_Lang[2]))
	{
	sprintf(add_file_name,"%s%.3s_%s",     /*  ࢮ ⠥ 䠩*/
		Config, Link[link].Lang,wbd_cfg);

	if (!stat(add_file_name,&f))
	   {
	   filein = fopen(add_file_name,rt);
	   for (i = 0; i < (WBD_MAX+1); i++)
	   				/* 横 ⥭ ப msg_wbd.cfg  */
		{			/* ᨢ wbd[]			   */
		if (wbd[i] != wbd0[i]) free(wbd[i]); else;
		fgets(Buffer, MINSEENBY, filein);
		if ((strlen(Buffer) < 5) || (strlen(Buffer) > 79))
		   wbd[i] = wbd0[i];
		else {
		     Buffer[strlen(Buffer) - 1] = '\0';
		     wbd[i] = malloc(strlen(Buffer) + 1);
		     if (wbd[i] != NULL) strcpy(wbd[i], Buffer);
		     else wbd[i] = wbd0[i];
		     }
		} /* for i < WBD_MAX + 1 */
	   fclose(filein);
	   prev_Lang[0] = Link[link].Lang[0];
	   prev_Lang[1] = Link[link].Lang[1];
	   prev_Lang[2] = Link[link].Lang[2];
	   } /* if !stat first add_file_name */
	else for (i = 0; i < (WBD_MAX + 1); i++)
		if (wbd[i] != wbd0[i])
			{
			free(wbd[i]);
			wbd[i] = wbd0[i];
			}
		else;
	} /* if Lang changed */
   else;
   Sqw_What_Bad();				/* look in Sqw_mw.c */
   } /* if area in commenting areas' list */
else;
#endif /* WHAT_BAD */
sprintf(add_file_name,"%s%.3s_%c%.2s.cfg",     /*  ண ⠥ 䠩*/
	Config, Link[link].Lang,Oo, Ext[area]+1);

if (!stat(add_file_name,&f))
   {
   filein = fopen(add_file_name,rb);		/*  䠩  ⥭    */
/*
Debug("filein = %p", filein);
Debug("f.st_size = %lu", f.st_size);
*/
   if (filein)
	{
	if (f.st_size < MINSEENBY)
	   readen = fread (Buffer,1,(size_t)f.st_size,filein);
	else readen = 0;
/*
Debug("readen = %lu",readen);
*/
	fclose(filein);
	}
   else readen = 0;
   Buffer[readen] = '\0';
   if ((!readen) || (readen != (size_t)(f.st_size)))
      strcpy(Buffer,Body_msg[(area == AREAKIL)]);
   else;
   }
else strcpy(Buffer, Body_msg[(area == AREAKIL)]);

msg_netmail_end(link);
}/* Sqw_comment() */

/* - - - - - - - Notification about deleting echomail. - - - - - - - - - - - */
void Sqw_notice(int link, char *lline)
{
sprintf(subj,"%.13s - %lu days old", lline, days);
Sqw_comment(link, AREAKIL, 0);
}/* Sqw_notice() */

#endif /* #else COMMENT_NOTICE_BAT */

void msg_netmail_begin(int link, int area)
{
int arorig;

mh.PakdMessage = 2;
mh.AttributeWord = 0;
mh.destNode = Link[link].Node;
mh.destNet  = Link[link].Net;

arorig = Area[area].Org;

mh.origNode = My[arorig].Node;
mh.origNet  = My[arorig].Net;

fwrite(&mh, sizeof(mh),1,fileout);		/*  	     */
fwrite(tofrom,13,1,fileout);			/*   ToFrom	     */
fwrite(subj,strlen(subj)+1, 1, fileout);	/*   Subj	     */

if (Link[link].Zone != My[arorig].Zone)
   fprintf (fileout,  Format_INTL,
    Link[link].Zone, Link[link].Net, Link[link].Node,
    My[arorig].Zone, My[arorig].Net, My[arorig].Node);
else;

if (My[arorig].Point) fprintf(fileout, Format_FMPT, My[arorig].Point);
else;

if (Link[link].Point) fprintf(fileout, Format_TOPT, Link[link].Point);
else;

fprintf(fileout, Format_MSGID,
	My[arorig].Zone, My[arorig].Net, My[arorig].Node,(unsigned long)ttt);

} /* msg_netmail_begin() */

void msg_netmail_end(int link)
{
fprintf (fileout, Format_s, Buffer);
fprintf (fileout, sVersion, rTear,
        SQW_VERTYPE, SQW_VERSION, SQW_SUBVERS, your_compiler);
fputc('\r', fileout);
fputc('\0', fileout);
fputc('\0', fileout);
if (ferror(fileout)) OutLog2(LEV_LOOSE,"Comment message", Write_Error);
else
    {
    sprintf(Buffer,"Inform %hu:%hu/%hu.%hu about %s; %.3s",
	Link[link].Zone, Link[link].Net, Link[link].Node, Link[link].Point,
	subj, Link[link].Lang);
    printf (Format_sn, Buffer);
    OutLog (LEV_WARN,Buffer);
    }
if (fileout) fclose(fileout); else;
fileout = NULL;
} /* msg_netmail_end() */
