/* sqw-exis.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Check file and directory exista-   ணࠬ ஢ન  䠩  -
 * nce procedures.                    ४ਨ.
 */
#include "./sqw-inc.h"

int Sqw_exist (char *, char *);
int DirCheck(char *, int);

/*************************** files existance check! **************************
Receives  path  (with  BACKSLASH at   砥   ᫥讬    .
the  end of it) and mask. Returns 0   頥 0, ᫨  諮    
if  no  files matched exist at that   室饣 䠩,  1 - ᫨  -
path,  and 1  -  if at least 1 file      ⠪ 䠩.
matched exists.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
int Sqw_exist(char *path, char *mask)
{
char fullpath[MAXPATH+3];
struct stat buf; /* fixed by Netzah */
sprintf(fullpath, Format_ss, path, mask);
return !stat(fullpath, &buf); /* fixed by Netzah */
}

/************************* Directory existance check and create if not exist **
Receives  path  and  offset to it's   砥   ᬥ饭  ᫥ 
last backslash.                       ᫥.

Returns 1 if success (directory al-   頥 1  ᯥ (㦥   ४-
ready exists or created), and 0  if     ᯥ譮 ᮧ),  0, ᫨ 
no  directory exists even after our        㤠 ᮧ.
attempts to create it.

If directory doesn't exist,  writes   ᫨ ४ਨ ⠪  -   ⮬
to log about it.                       -䠩.
- - - - - - - - - - - - - - - - - -   - - - - - - - - - - - - - - - - - - - - -
Function is written recursively.      㭪 ࠡ⠥ ४ᨢ.

Non-recursive, linear path creation   ४ᨢ, " 砫  " ᮧ-
'from the beginning to end' MAY ca-       ਢ  -
use permission errors if full  path    䠩 ⥬   訡 -
is used on some file systems.         .   ⥫.
- - - - - - - - - - - - - - - - - -   - - - - - - - - - - - - - - - - - - - -*/

static	char	Cant_Create_and_Use[] = "): Can't create or use as directory!";
static	char	tmpath[MAXPATH+3];
static	char	tmpath1[MAXPATH+3];
static	char	*path;
static	struct stat statbuf;
static		FILE *tempfile;

static int dircheck(int);
static void tmpnam_my(char *, char *);

int DirCheck(char *ppath, int length)
{
if (Cfg_DirCheckFast == 2) return 1; else;
path = ppath;
return dircheck(length);
}/* DirCheck() */

/******************** The dircheck stat version ****************************/

int dircheck(int length)
{
char c = path[length];
path[length] = '\0';
statbuf.st_mode = 0;

if ((length == 0) || 				/* If left side of path  */
    ((length == 1) && (*path == BACKSLASH)))	/* reached - special chk */
	goto Unsuccess;
else;

if (!Cfg_DirCheckFast)
 {
 if (!stat(path,&statbuf)) /* ⠪  */
   {
   if  (IS_RWDIR(statbuf.st_mode))	/* IS_RWDIR defined in sqw-os.h     */
	goto Success;			/* ४  ࠢ묨 ࠢ */
   else goto st_exit_with_err;		/*  ४   ࠢ */
   } /* if !stat(path,...) */
 else					/* ⠪    - ᮧ   */
   {
   if (MAKEDIR(path) == 0) goto Success; else;
   if (errno == ENOENT)			/* No directory on upper level	     */
	{ int i=length;			/*  ४ਨ ।饣 ஢ */
	while((i>0) && (path[i] != BACKSLASH)) i--;
	if (dircheck(i))		/* ᮧ . ।饣 ஢   */
		if (MAKEDIR(path) == 0) goto Success;
		else goto Unsuccess;
	else goto st_exit_with_err;
	}
   else goto Unsuccess;
   } /* else !stat(path,...) */
st_exit_with_err:
 sprintf (tmpath, "%s (st_mode 0%0o%s",
           path, statbuf.st_mode, Cant_Create_and_Use);
 }
else /* Cfg_DirCheckFast == 1 */
 {
/******************** The DirCheck Stupid version *****************************
Attention! This code is written  in   !     ᠭ  ᨬ쭮
maximal OS-independent form. But it   ᨬ  .   砥 -
means  slow  execution.  It  causes   ⢥  ࠡ.   ᮧ  
creation/deletion  temporary  files     ࠥ ६ 䠩    
in every real needed directory, and   ॠ쭮  襩  ४ਨ, 
it is not the best choice.               襥  襭.

                                        ஢ २ 䠩.
And it checks renaming files...
                                      ᫨  㬠,     ਢ-
If you  think,  that some checkings     ஢ப  㦭 -  ४-
are not needed - I recommend you to     ᬮ  ᠭ ࠢ  -
see at Novell's  or Lantastic's ac-   㯠    ⨪...  㦠-
cess rights'  tables...  It's awful    -  , ।ᬠਢ騩 -
to write REALLY full checkings...       樨  ஢騩 !
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
 tmpnam_my(tmpath, path);
/**
Debug("(DirCheck_Stupid version) \"%s\"", path);
**/
 tempfile = fopen (tmpath,wb);/* ⪠ ᮧ 䠩  ४ਨ */
 if (tempfile != NULL)
   	{			/* 㤠 ᮧ 䠩  ४ਨ */
/**
Debug("tempfile = %p", tempfile);
**/
   	fclose(tempfile);
   	tmpnam_my(tmpath1, path);
   	if (rename(tmpath, tmpath1))
   		{		/*  㤠 २ 䠩     */
   		remove(tmpath);
   		goto exit_with_err;
   		}
   	else;
	if (!remove (tmpath1)) goto Success;/* 㤠     */
   	else goto exit_with_err; /*  㤠  ᮧ 䠩*/
   	} /* if tempfile != NULL */
 else	{
/*
 * Can't create temporary  file  in     ᮧ ६  䠩    ⮩
 * path - different situations:       ४ਨ -  稭:
 * - directory doesn't exist          -   ४
 * - wrong access rights/owner        -  ࠢ 㯠/
 * - file at the place of directory   -   ४ਨ - 䠩
 */
	if (MAKEDIR(path) == 0) goto Success; else;

	if (errno == ENOENT)
		{ int i=length;		/*  ४ਨ ।饣 ஢ */
		while((i>0) && (path[i] != BACKSLASH)) i--;
		if (dircheck(i))	/* ᮧ . ।饣 ஢   */
			if (MAKEDIR(path) == 0) goto Success;
/*
 * This code assumes, that success-     ࠧ㬥,     ᫨  
 * fully created directory does not   㬥 ᠬ ᮧ ४ -   -
 * need checking for create/rename/      ᮧ/२/-
 * delete files in it...              ࠭ 䠩 -⠪  .
 */
			else goto Unsuccess;
		else goto exit_with_err;
		} /* if errno == ENOENT */
	else	{
/*
 * Directory isn't created for some    㤠 ᮧ ४, 稭 
 * reason. Stupid version can't de-     ४⭮ ஢ -
 * tect REAL reason.                  ᨬ .
 *
 * We DO NOT delete file  encounte-   ⨢訩  ⮬  䠩 ⥯, 
 * red on this  path,  as  previous   ⫨稥  । ᨩ,  ࠥ-
 * versions did.                      !
 */
		goto exit_with_err;
		} /* else errno == ENOENT */
	} /* else tempfile != NULL */
 exit_with_err:
 sprintf (tmpath, "%s (stupid check%s",path, Cant_Create_and_Use);
 } /* else Cfg_DirCheckFast == 1 */
Errexit (tmpath, Erl_Directory);

Unsuccess:
path[length] = c;
return 0;

Success:
path[length] = c;
return 1;
} /* dircheck() */

/*-----------------------------------------------------------------------------
Additional function adds  temporary   ⥫쭠 㭪 -   
filename to path, with idiotic idea    ६ 䠩, 室  -
about different results of  library   ᪮ ।  ࠧ १,
function tmpnam()...                  頥 筮 tmpnam()...
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Receives  -  path pointer, assumes,   砥 㪠⥫  , ࠧ㬥,
that no BACKSLASH at it's end,  and     砥 㫥 ⮬   -
zero byte is the end of path. Assu-      ᫥. ࠧ㬥,  -
mes, that tmpath has enough length.   騩  ...
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void tmpnam_my(char *tmpath, char *path)
{
char *stmp = tmpnam(NULL); int itmp = strlen(stmp);

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
This two  lines are needed, because     ப 室, ⠪  
function  tmpnam() may return  very   ࠧ묨 /ࠬ tmpnam() -
different result in different OS or   頥 ࠧ १  -    
compilers - it may contain tempora-   ᮤঠ    ६ 䠩,  
ry path or not. So -  we  get  only     .    ⤥  
filename from it.                     ⮥  䠩.

Than, I don't  check  the  received     ஢    ⮣
name to be valid in  this OS  -  if    -  ᫨ 騩    -
your compiler  and library  creates    ᣥਫ ୮    
here  invalid  name  -  it's not my   - , ,    ஡.
problem, sorry. ;-)

 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
	   do itmp--;
	   while ((itmp >0) && (stmp[itmp] != '\\') && (stmp[itmp] != '/'));
	   if ((stmp[itmp] == '\\')|| (stmp[itmp] == '/')) itmp++; else;

/* compose full path from analyzed path, delimiter and temp file name */
	   sprintf (tmpath, "%s%c%s", path, BACKSLASH, stmp + itmp);

} /* tmpnam_my() */
