/* sqw-log.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Log writing functions.             㭪樨   -䠩.
 * Debug printing functions.          㭪樨 ⫠筮 .
 */

#include "./sqw-inc.h"

void Errexit(char *, int);
void OutLog(int, char *);
void OutLog2(int, char *, char *);
void LogPktLine(int, int, char *);
/* =========================================================================
                               OutLog()
Writes new line, date, time             ப, , ६,
"name" of programm and lline.          ணࠬ  lline.
                               OutLog2()
The same, but two lines concatenat.     ᠬ,   ப .

                               Errexit()
* ========================= 뢮 ப   室  ૥ ======= */
void Errexit(char *A,int B)
{
OutLog2(LEV_ABORT,A,crlf);
if (B) OutLog2(LEV_ABORT,Exiting,crlf); else;
puts(A);
#ifdef UNIX
if (Cfg_UseSyslog) closelog(); else;
#endif
exit(B);
}

#ifdef UNIX
static unsigned int priotab[] = {
					LOG_NOTICE,
					LOG_NOTICE,
					LOG_NOTICE,
					LOG_INFO,
					LOG_INFO,
					LOG_DEBUG,
					LOG_DEBUG,
				};
static char	tmplline[MAXPATH * 2];
#endif

void OutLog(int loglevel, char *lline)
{
OutLog2(loglevel, lline, "");
}

void OutLog2(int loglevel, char *lline, char *lline2)
{
#if (!SYSLOGONLY)

char levels[] = "!?*:-+ ";
char *timeline;
int i;
time_t timer[1];

if (loglevel > Cfg_LogLevel) return; else;

#endif

#ifdef UNIX
if (!Cfg_UseSyslog) {
#endif

#if (!SYSLOGONLY)

time(timer);
timeline = ctime (timer);
/*-------------------------------------------------------------------------
I assume format of ctime-returned      ࠧ㬥 ଠ ப,
line as:                             饭 㭪樥 ctime():
                     "Sun Jul 28 12:58:12 1996\n"
And convert it to:                    ॢ  :
                     " 28 Jul 12:58:12 "
symbol position >     012345678901234567 <  ᨬ
-------------------------------------------------------------------------*/
timeline[0]=' ';
timeline[1]=timeline[8];
if (timeline[1] == ' ') timeline[1] = '0'; else;
timeline[2]=timeline[9];
for (i=8; i <= 16; i++)
    timeline[i]=timeline[i+3];
timeline[17]='\0';

if ((Log_file == NULL) || ferror(Log_file))
	{
	fputs ("Error open/write log... Rerouted to stderr", stderr);
	if (Log_file) fclose(Log_file); else;
	Log_file = stderr;
	}
fprintf (Log_file, "\n%c%.19sSQSH %s%s",
		levels[loglevel], timeline, lline, lline2);
#endif /* !SYSLOGONLY */

#ifdef UNIX
	} /* if !Cfg_UseSyslog */
else	{
	if ((strlen(lline) + strlen(lline2)) < (MAXPATH*2))
		{
		sprintf (tmplline, Format_ss, lline, lline2);
		syslog(priotab[loglevel], tmplline);
		}
	else 	{
		syslog(priotab[loglevel], lline);
		syslog(priotab[loglevel], lline2);
		}
	}
#endif
}
/*****************************************************************************
 * Prints line about pkfile to  log   뢮  ப      
 * with filename, and to  stdout  -   pkt-䠩,   ⠭ 뢮  -  
 * w/o filename (assumes it's alre-    (ࠧ㬥,     㦥  㤠
 * ady printed).                      뢥).
 * ------------------------------------------------------------------------- */
void LogPktLine(int loglevel, int pktnum, char *lline)
{
sprintf(Buffer, "%8.8s: %s", PKTFile[pktnum]+Inb_Len, lline);
printf(": %s\n", lline);
OutLog (loglevel, Buffer);
}

#if DEBUG
#include "./_debug.c"
#endif /* DEBUG */
