/* sqw-rgx.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Regular Expressions functions.       ॣ묨 ࠦﬨ.
 *
 */

#include "./sqw-inc.h"

int rgx_here(char *);
int rgx_cmp(char *, char *, int);
int strcasecmp_match(char *, char *);
void rgx_Line(int *, int, int);

int SearchTwit(unsigned int);
/*=============================================================================
Is regular expression here? returns      ப ॣ୮  ࠦ?
0 if it's presize line, 1 if  there   0 - ப "筠",  ॣ ࠦ.
is regular expression,	-1 if there   1 - ४⭮ ॣ୮ ࠦ.
is wrong regular expression syntax.   -1 - 訡 ᨭ⠪ ॣ ࠦ.

Now regexp is only simple wildcards    ॣ - ⮫쪮 *? -  -
- so, no error may be happened.  If      . ᫨  ⠪ -
I'll  write  regular expressions  -     ॣ. ࠦ -    㤥
checking will be here...	      ஢ઠ.
-----------------------------------------------------------------------------*/
int rgx_here(char *s)
{
if (s) return 1; else return 0;
}
/*=============================================================================
Reads  characters till 0 to Buffer,   ⠥ ᨬ  Buffer, ࠢ -
compares with one  of  From/To/Subj   稢 ப  ॣ ࠦ	  -
regexps for Rules extracting.  hash   権 RulesFrom/To/Subj. ࠬ hash 㪠-
is marker - what regexp is used.      뢠,    ॣ ࠦ.

Returns:			      頥:
0 - No matched Rules??? regexp.       0 -  諮 室饣 ࠦ.
1 - Matched regexp found.	      1 - 諮 室饥 ࠦ.
EOF - EOF or too long line.	    EOF -  䠩; ப ᫨誮 .

Changes:			      :
*A - last symbol have been read.      *A - ᫥ ⠭ ᨬ.
-----------------------------------------------------------------------------*/
void rgx_Line(int *A, int msgnum, int hash)
{
#if AREAFIX_STYLE
char tmp_line[9];
#endif
char *s0 = Buffer;		/* 㪠⥫   */
int  len, limit;		/*  ப  稪/࠭⥫ */

if (hash == HASH_RulesSubj) limit = 72; else limit = 36;
len = 0;
do {				/* ⠥  0   EOF'a */
   *A = fgetc(filepkt);
   len++;
   if ((*A == '\0') || (*A == EOF)) break;
   else {
	if (Cfg_CheckFields && (*A < 32) && (Msg[msgnum].WhatBad != WBD_FIELDS))
			/* ᫨ 祭 ஫ ᨬ   */
		{
		Msg[msgnum].Area = AREABAD;
		Msg[msgnum].WhatBad = WBD_FIELDS;
		}
	else;
	*s0++ = (char)*A;
	}
   crc = CRC_ADD(*A,crc);
   }
while (limit--);
*s0 = '\0';
if ((*A == EOF) || !limit) /* ᫨ ࢠ ᠣ  ᫨誮   */
    {
    Msg[msgnum].Area = AREABAD;
    Msg[msgnum].WhatBad = WBD_FIELDS;
    OutLog(LEV_POSSIBLE,crashed_last_msg);
    return;
    }
else  {
      switch (hash)
	 {
	 case HASH_RulesFrom:
		Msg[msgnum].LFrom = len;
		Msg[msgnum].AFIX &= !SearchTwit(HASH_IgnoreMsgsFrom);
		break;
	 case HASH_RulesTo:
		Msg[msgnum].LTo = len;
		Msg[msgnum].AFIX &= SearchTwit(HASH_Alias);
		break;
	 case HASH_RulesSubj:
		Msg[msgnum].LSubj = len;

#if (AREAFIX_STYLE)
/*
 * Result of this analysis is:	         From/To/Subj:
 * AREAFIX, AFIX=1 - correct msg to   AREAFIX, AFIX=1 - ࠢ  
 * our AREAFIX to be replied.	      襬 ॠ䨪, ࠡ⠥ .
 * AREAFIX, AFIX=0 - incorrect	msg   AREAFIX, AFIX=0 -  ४  
 * to our AREAFIX to  be  commented    襬 ॠ䨪, 㤥 ⪮-
 * with proper WBD_AF_... line	        ᮮ⢥饩 ப WBD_AF_...
 *
 */
		if (!Msg[msgnum].AFIX) break; else;
		Msg[msgnum].AFIX = 0;
		Msg[msgnum].Area = AREAFIX;
		Msg[msgnum].WhatBad = WBD_UNKNOWN;
		if  ((Msg[msgnum].Link > Link_Num) ||
		     (*Link[Msg[msgnum].Link].FIXPassword == '\0'))
		     Msg[msgnum].WhatBad = WBD_AF_NOLINK;
		else {
		     s0 = Link[Msg[msgnum].Link].FIXPassword;
		     for (limit = 0; limit < 8; limit++)
		       tmp_line[limit] = *s0++;
		     tmp_line[8] = '\0';
		     if (strcmp(tmp_line, Buffer))
			Msg[msgnum].WhatBad = WBD_AF_WRONGP;
		     else Msg[msgnum].AFIX = 1;
		     } /* else link > Link_Num || *passw == '\0' */
#endif
	 default: break;
	 } /* switch (hash) */
      Msg[msgnum].rule &= SearchTwit(hash);
      } /* else *A==EOF || !limit  */
} /* void rgx_Line */
/* - - - - - - - - - - loop of looking for rules in twitline - - - - - - - - */
int SearchTwit(unsigned int hash)
{
int tw;
unsigned long twit_off = Twit_Sum;

for (tw = Twit_Num-1; tw >= 0; tw--)
	{
	twit_off -= Twit[tw].Len;
	if (Twit[tw].Hash == hash)
	   {
	   if(rgx_cmp(Buffer,(char *)(Twit_Lin + twit_off),(int)Twit[tw].Len))
	     continue;
	   else
	     {
	     return 1;
	     }
	   }
	else;
	} /* for tw = Twit_Num-1 */
    return 0;
}

/*=============================================================================
Compare string with regular expres-   ࠢ ப  ॣ  ࠦ
sion in my situation  (when expres-     樨 ( ப  ࠦ-
sion string is part of	Rul_Lin  or    ᮤন  Rul_Lin  Twit_Lin  
Twit_Lin and has no zero byte after    㫥   .
it).
 str - string zero-terminated	      str - 񭭠  ப
 exp - string non-terminated	      exp - 񭭮  ࠦ
 length is length of EXPRESSION!      length -   !

 Returns:	   0 - matched;       頥: 0 - ப ᮮ⢥ -
 1 - not matched; -1 - abort.	      ࠦ. 1 -  ᮮ⢥. -1
-----------------------------------------------------------------------------*/
int rgx_cmp(char *str, char *exp, int length)
{
int ret = 0;
char c = exp[length];
exp[length] = '\0';
switch (Cfg_RegExp)
	{
	default:
	case 0: ret = strcmp(str, exp); break;
	case 1: ret = strcasecmp_match(str, exp); break;
	}
exp[length] = c;
return ret;
}

int rgx_cmp2(char *str, int lengthstr, char *exp, int length)
{
char c = str[lengthstr];
int ret = 0;
str[lengthstr] = '\0';
ret = rgx_cmp(str, exp, length);
str[lengthstr] = c;
return ret;
}
#include "./strmatch.c"
