/*sqw-tag.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Find EchoTag function.             㭪 ᪠ ⠣.
 *
 */

#include "./sqw-inc.h"

/* ============================================================================
Returns  number of echoarea if  tag   頥  宮, ᫨ 
is found,  and zero - if not found.   ⠣,   - ᫨  . ࠢ-
Compares  line from s0 by length...    ப   s0  length.

Uses (not changes):                                ᯮ ( ):

               Tag_Lin, Tag_Len, Tag_Sum, Area_Num, Area[].Tag

******************************************************************************/

unsigned int Find_Tag(char *s0, unsigned int length_string)
{
unsigned int arnum = AREA1ST;
char huge *sptr = Tag_Lin;
char c;
if ((length_string == 0) || (length_string > (unsigned)(Tag_Len + 1)))
   return 0; else;

c = s0[length_string];
s0[length_string] = '\0';
length_string++;

while (arnum < Area_Num)
	{
	if (length_string == (unsigned int)Area[arnum].Tag)
	   if (!strcmp((char *)sptr,(char *)s0)) break; else;
	else;
	sptr += Area[arnum++].Tag;
	}

length_string--;
s0[length_string] = c;

if (arnum >= Area_Num) return 0; else return arnum;
} /* Find_Tag() */

/* ============================================================================
 * Search next echotag  matched  to    ᫥饣 ⠣,  室饣  
 * regular expresion.                 ॣ୮ ࠦ.
 *
 * Returns number of area found.      頥   宮.
 *
 * If not found - returns 0 and re-   ᫨   - 頥 0  -
 * sets to the beginning search.          ᠬ 砫 ᯨ᪠ .
 *
 *****************************************************************************/

unsigned int Find_Next_Tag(char *regexp, unsigned int length_string)
{
static char huge *sptr;			/* current offset in Tag_Lin */
static unsigned int  arnum = 0;		/* current area number       */
static char c;				/* saved symbol after regexp */

if (arnum == 0)
	{
	if (length_string == 0) return 0; else;
	sptr = Tag_Lin;
	arnum = AREA1ST;
	c = regexp[length_string];
	regexp[length_string] = '\0';
	}
else;

while (arnum < Area_Num)
	if (!strcasecmp_match((char *)sptr,(char *)regexp)) break;
	else sptr += Area[arnum++].Tag;

if (arnum >= Area_Num)
	{
	regexp[length_string] = c;
	arnum = 0;
	return 0;
	}
else	{
	sptr += Area[arnum++].Tag;
	return (arnum - 1);
	}
} /* Find_Next_Tag() */
