/* sqwarc.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * (C) 1998 Sergej Qkowlew     2:5020/122@fidonet                ࣥ 
 *
 *                               V01.00
 *
 * Tool for  packing oubound  files   ணࠬ 㯠  室 બ  
 * with using rules in  squish-like   ਬ ࠢ  ᪢订  䠩 
 * file compress.cfg.                 ᠭﬨ 娢஢ - compress.cfg.
 *
 * Replaces (in UNIX version) batch     UNIX ᨨ  䠩  
 * DOS file sqwarc.bat, calling  by   sqwarc.bat, 뢠  sqwash.bat.
 * sqwash.bat.
 *
 * Checks/Creates .bsy flags.         ஢/ᮧ ४⭮ .bsy 䫠.
 *
 * For existant arcmails checks ar-    㦥 騥 બ  뢠
 * chiver's type and  run  archiver   娢஬    ᮮ⢥⢨  ᮤন
 * according to it's real type, not   બ,    㪠  ⮬  -
 * by described by argv[5].            ᪠.
 *
 * Version 01.00+:
 *
 * If zero-length  arcmail detected   ᫨  ଠ쭮 બ -
 * instead of normal file - program     - ணࠬ  "६-
 * 'increments' file  extention  to   " ७ 䠩,     
 * find non-existant. If all possi-   ᢮. ᫨   ७
 * ble extentions are busy  -  take    䠩 -  ᫥ -
 * last found;  if arcmail is trun-   ; ᫨ બ  ⨬ ७ -
 * cated - delete it, then create.     -     ᮧ.
 *
 * Now we read .DLO file  to  check     ஢塞  稥  뫪  
 * existance of reference  to  arc-   બ  䠩 .DLO,  塞 뫪
 * mail, and reference is added on-   ⮫쪮 ᫨  ⢨⥫쭮  室-
 * ly if really needed.               .
 *
 * errorlevel 0 - success
 * errorlevel 1 - some error
 *
 * Bink-Style Only                    쪮 -⠩ .
 *
 * Distribution:                      ᮡ ࠭:
 * Source code under GNU license.      室 ⥪,  ࠬ GNU.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>

#include "./sqw-os.h"	/* OS-aware definitions */
#include "./sqw-cfg.h"

/* =========== ⨯   㭪権 =========================== */
void	OutLog(char *);
char	*Read_Compress_Cfg(void);
void	ExecVp(char *);
int	System(char *);
void	Write_Line_Back(int, char **, char *);
void	Write_Line_Dlo(void);
int	Move(char *);
void	FindExt(char *);
void	Remove_arc(int, char **);

#if (!defined(UNIX))

#include <process.h>

#define openlog(A,B,C)
#define syslog(A,B)
#define closelog()
#else
#include <sys/types.h>
#include <sys/wait.h>
#endif

#include "./sqw-bsy.c"	/* .bsy files creation and deleting subroutines	*/

static char Begin_Extract[] = YOUR_OS;
int  Cfg[Cfg_Verbs_Num];
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define MAXARGS 200	/* ᨬ쭮 ⢮ 㬥⮢ argv[]	    */
#define ARCMAX 40	/* ᨬ쭮 㥬 ᫮ 娢஢	    */
#define MAXLINE 4097	/* ᨬ쭠  ப 䨣 compress.cfg   */
#define LENEXT 3	/*  ७ 䠩 (᫥ ᫥ 窨)   */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static	int	LowerCase = 1;
static	char *dlo[] = {".DLO", ".dlo"};	/* Extention for .?LO files	    */
static	char *out[] = {".OUT", ".out"};	/* Extention for .OUT files	    */
static	char *pkt[] = {".PKT", ".pkt"};	/* Extention for .PKT files	    */
static	char *Ss[]  = {"S", "s"};	/* s. filename			    */
static	char *Ee[]  = {"E", "e"};	/* e. filename			    */
static	char *Aa[]  = {"A", "a"};	/* to increment last char of ext    */
static	char *Zz[]  = {"Z", "z"};	/* to increment last char of ext    */
static	char *Format_ss = "%s%s";

char	Buffer[MAXLINE+2];/*  ப    䠩 ଠ樨	    */
char	*pathname_dlo;
char	*pathname_out;
char	*pathname_pkt;
char	*pathname_arc;			/* arcmail path+name+ext	    */
char	*arctype = "ZIP";		/* Default packer if no %5 param    */

static char	*compress_cfg = "compress.cfg",		/*  䨣	    */
		rb[] = "rb", at[] = "at", rt[]="rt";	/* ਡ fopen   */
static char const tabspace[] = " \t";			/*  strtok	    */
static char	before_path;		/* # or ^ in .dlo file		    */
static struct stat f;			/*   㭪樨 stat	    */
static FILE *filein, *filebat, *filelog;/* ਯ  fopen/...	    */

/*  १ ࠡ⪨ compress.cfg ࠧ : - - - - - - - - - */
static unsigned int  Num_Arcs;		/* ᪮쪮 稫 娢஢   */
static          long Offset[ARCMAX];	/* 饭  Ident		    */
static unsigned long Length[ARCMAX];	/*  ᫥⥫쭮 ⮢  */
static unsigned char *Ident[ARCMAX];	/*  ᫥⥫쭮 ⮢   */
static unsigned char *Add[ARCMAX];	/* ப  ᪠ 娢    */
static unsigned char *Name[ARCMAX];	/*  娢 (Pack)    */
static		int  ArcNow = -1;	/*  娢 ப ᪠  */
static		int  arcmail_not_here;	/* 稥 બ argv[3]         */
static unsigned	char tmp[MAXLINE];	/* ஬筠 ப		    */
static 		char *args[MAXARGS];	/* ப  execvp/spawnvp	    */

/* ============================================================================
 * Runs execvp(), but receives  one   ᪠ ப, ।⥫쭮 ࠧࠢ
 * line argument. Divides it to to-     ⮪  ।  ⠪  㭪-
 * kens and runs...                   樨 execvp().
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
void	ExecVp(char *line)
{
int j;
args[0] = strtok(line, tabspace);
j = 1;
do args[j] = strtok(NULL, tabspace);
while (args[j++] != NULL);
execvp(args[0], (char ** const)args);
exit(1);		/*  稫 ᯮ   */
} /* ExecVp() */

/* ============================================================================
 * Invoke system command and return   맢 ⥬      
 * with errorlevel to be analysed.    祭  襭  .
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
int	System(char *line)
{
int j,k;

args[0] = strtok(line, tabspace);
j = 1;
do args[j] = strtok(NULL, tabspace);
while (args[j++] != NULL);

#ifdef UNIX
if(fork())
	{			/* த⥫ ...    */
	wait(&k);
	k = WEXITSTATUS(k);	/* 稫       */
	}
else	{			/* ॡ񭮪 ᯮ  */
	execvp(args[0], args);
	exit(6);		/*  稫 ᯮ   */
	}
#else
/*
spawnvp(P_WAIT, "kmap", (char ** const)args);
getchar();
*/
k = spawnvp(P_WAIT, args[0], (char ** const)args);	/*  	*/
#endif
return k;
}

/* ============================================================================
 * Appends line of argv[]  to  file   뢠 ப   㬥⮢  argv  
 * named "s" or "e"  for later use,   䠩, 㥬 "e"  "s"   ⫮-
 * if packing can not  be completed     ⮬ ᯮ짮, ᫨ 㯠-
 * for some reason (.bsy flag  cau-         襭.  .bsy  䫠
 * ses file "s", packing errors - e   -  䠩 s, 訡 -  䠩 e.
 * ------------------------------------------------------------------------- */
void	Write_Line_Back(int argc, char *argv[], char *s)
{
register int i;
filebat = fopen (s,at);
if (filebat == NULL) exit(1); else;
for (i = 0; i < argc; i++)
	fprintf(filebat, "%s ", argv[i]);
fprintf (filebat, "\n");
fclose (filebat);
} /* Write_Line_Back */

/* ============================================================================
 * ------------------------------------------------------------------------- */
void	Write_Line_Dlo ()
{
int reference = 1;

errno = 0;

/* V01.00+ */
filebat = fopen (pathname_dlo,rt);
if (filebat)
   {
   while(fgets(tmp,MAXLINE,filebat) && reference)
#if (defined(__TURBOC__))
	if (!strnicmp(tmp + 1, pathname_arc, strlen(pathname_arc)))
#else
	if (!strncmp(tmp + 1, pathname_arc, strlen(pathname_arc)))
#endif
		reference = 0;

	else;
   fclose(filebat);
   if (!reference) return; else;
   }
else;
/* V01.00- */

filebat = fopen (pathname_dlo,at);
if (filebat)
	{
	fprintf(filebat, "%c%s\n", before_path, pathname_arc);
	fclose(filebat);
	}
else;
if ((filebat == NULL) || (errno))
	OutLog ("Can't append line to .dlo");
else;
} /* Write_Line_Dlo */

/*****************************************************************************
 *
 * --------------------------------------------------------------------------*/
void Remove_arc (int argc, char **argv)
{
if (remove(argv[3]))		/*   	     */
   {			/* 㤠筠 ⪠  */
   Write_Line_Back (argc, argv, Ee[LowerCase]);
   bsy_remove();
   exit(1);
   }
else;
} /* void Remove_arc */

/* ===========  ணࠬ ========================================== */
void main (int argc, char *argv[])
{
#if (defined(__TURBOC__))
short int dummy;	/* 窠 ⨢  ࡮- 2.0                */
#endif
char *s0, *s1, 		/* ⥫  ࠧ ப			    */
	*lastchar;	/* ᫥ ᨬ ७ બ		    */

int	k;
time_t ttt;
/* - - - - - - ⢥ ᯮ塞  - - - - - - - - - - - - - - - - - */
time(&ttt);
/* ======================= Command Line help ============================== */
if (argc <= 1)	{
printf ("%s%s%s%s%s%s%s%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
"SqWarc V01.00/", YOUR_COMPILER, " (C) Sergej Qkowlew 2:5020/122\n\n",
"Under GNU Public License\n",
"Arcmail PACKer for Bink-style OutBound with compress.cfg using.\n",
"Replaces DOS batch version sqwarc.bat under UNIX\n",
"Parametres of calling are like this line:\n\n",
"   ./sqwarc D:/OUT.SQ/37723456 D:/OUT/139C0025 D:/HOLD/00000055.MO1 ^ [ZIP]",
#ifdef UNIX
"                                                                   ",
"path to .out w/o ext  $1    $2             $3                  $4$5",
#else
"                                                                   ",
"path to .out w/o ext  %1    %2             %3                  %4%5",
#endif
"                                                                    ",
"path to .dlo w/o ext in BSO                                      ",
"or local path to place .PKT here if packer LOC                       ",
"                                                                     ",
"full path to arcmail,                       ",
"or full path to .o?? file to be sent to link non-packed,              ",
"or target file extention, if LOC archive type.                        ",
"# or d for Trunc/Sent, ^ or g for Del/Sent in BSO,  ",
"The archive type  ");
		exit (0);
		}
else;

/* ========================================================================= */
pathname_arc = argv[3]; lastchar = pathname_arc + strlen(pathname_arc) - 1;
before_path = *argv[4];
LowerCase = 0;
if (before_path == 'd') {LowerCase = 1; before_path = '#';} else;
if (before_path == 'g') {LowerCase = 1; before_path = '^';} else;

pathname_out = malloc(strlen(argv[1]) + 5);
if (argc != 5) arctype = argv[5]; else;

/* ------------------ Move file to LocalPath ------------------------------ */
if ((argc == 6) && (!stricmp(argv[5], "LOC")))
    {
    sprintf(pathname_out,"%s.%s", argv[1], argv[3]);	/*  .o?? */
    exit(Move(argv[2]));
    } /* if LOC */
else;

/* ------------------ Check - what .o?? file exists here? ----------------- */
sprintf(pathname_out,Format_ss, argv[1], out[LowerCase]);
if (stat(pathname_out,&f))
   {
   s0 = argv[3] + strlen(argv[3]) - LENEXT - 1;	/* s0 - 㪠뢠 ७ */
   						/* 室 䠩           */
   sprintf(pathname_out,Format_ss, argv[1], s0);
   if (stat(pathname_out,&f))
	{
	sprintf (Buffer, "%s - Not found file to be sent", pathname_out);
	OutLog(Buffer);
	Write_Line_Back (argc, argv, Ee[LowerCase]);
	exit(1);
	}
   else	{	/*  뫠 䠩,    .out -     */
	arctype = NULL;
	} /* esle stat("name.ops,...") */
   } /* if stat("name.out") */
else;

if ((before_path != '#') && (before_path != '^')) exit(1); else;

openlog("sqwarc", LOG_PID | LOG_CONS, LOG_USER);

pathname_pkt = malloc(strlen(argv[1]) + 5 + 9);
pathname_dlo = malloc(strlen(argv[2]) + 5);
sprintf(pathname_dlo,Format_ss, argv[2], dlo[LowerCase]);
sprintf(pathname_pkt,Format_ss, argv[1], pkt[LowerCase]);

if (bsy_create(argv[2], ".bsy") == -1)/*    */
	{
	Write_Line_Back (argc, argv, Ss[LowerCase]);
	exit(0);
	}
else if (arctype)
	{				/*  ᮧ ᢮    */
/* V01.00+ (Was trivial removing zero-length arcmail) */
	do {
	   arcmail_not_here = stat(pathname_arc,&f);
	   if (!(arcmail_not_here)) /*  બ */
	      if (f.st_size == 0L)			/*  㫥  */
		{
		if ((before_path == '#') &&	/* ᫨  ᥪ */
		    ((*lastchar) < *(Zz[LowerCase])))/*      */
		    if ((*lastchar) == '9')
		    	 *lastchar = *Aa[LowerCase];
		    else (*lastchar)++;
		else {				/*    */
		     Remove_arc(argc, argv);
		     arcmail_not_here = 1;
		     }
		} /* if (f.st_size == 0L) */
	      else break;			/* 㫥 બ */
	   else break;				/*  બ */
	   }
	while (!arcmail_not_here);
/* V01.00- */
	s1 = Read_Compress_Cfg();
#if DEBUG
/**/ printf ("\n%s\n", s1);
#endif
	if (s1 == NULL)			/* ᫨   娢 */
		{
		Write_Line_Back (argc, argv, Ee[LowerCase]);
		bsy_remove();
		exit(1);
		}
	else;
	if (rename (pathname_out, pathname_pkt))
		{
		Write_Line_Back (argc, argv, Ee[LowerCase]);
		bsy_remove();
		exit(1);
		}
	else;
	k = System (s1);
#if DEBUG
/**/	printf ("\nReturned code %i\n", k);
#endif
	if (k == 0)
		{
		/* V01.00+ Check line existance, not arcmail existance */
		Write_Line_Dlo();
		remove(pathname_pkt);
		}
	else	{
		rename(pathname_pkt,pathname_out);
		sprintf(Buffer,"Error packing %s to %s",
			pathname_pkt, pathname_arc);
		OutLog(Buffer);
		Write_Line_Back (argc, argv, Ss[LowerCase]);
		}
	bsy_remove();
	} /* else bsy_create if arctype*/
    else{
	if ((k = Move(argv[3])) == 0)
	   Write_Line_Dlo();
	else {
	     sprintf (Buffer,"Can't move %s to %s", pathname_out, argv[3]);
	     OutLog(Buffer);
	     Write_Line_Back (argc, argv, Ee[LowerCase]);
	     }
	bsy_remove();
	} /* else arctype */
closelog();
exit(k);
} /* main() */

/* ============================================================================
 * Returns 0 if success
 * Or result of System or unlink.
 * ------------------------------------------------------------------------- */

int Move (char *kuda)
{
#ifdef UNIX

link(pathname_out, kuda);
switch(errno)
	{
	case 0:
		if (unlink(pathname_out)) return 1; else return 0;
	case EXDEV:    case EPERM:    case EMLINK:
/*
 * If link is impossible  for  some   ᫨  ᤥ  link    
 * reasons  -  shell command  mv is   稭 - 뢠  襫 mv.
 * invoked.
 */
		sprintf (Buffer, "mv %s %s", pathname_out, kuda);
		return (System (Buffer));
	default:
		return 1;
	} /* switch errno */

#else	/*   ᮬ 襢 ࠧ  move */
	sprintf (Buffer, "move /Y %s %s", pathname_out, kuda);
	return(System (Buffer));
#endif
} /* int Move() */

/* ============================================================================
 * Reads compress.cfg and fills ta-   ⠥ compress.cfg,  ⠡窨.
 * bles.
 *
 * Returns command line.              頥  ப.
 * ------------------------------------------------------------------------- */

char *Read_Compress_Cfg()
{
int matched, i,j,k;
char *s0,*s1;

if ((filein = fopen(compress_cfg,rb)) == NULL) exit(1);else;
/* ======================= Compress.cfg analysing ======================== */
i = 0;					/*  ⥪饣 娢	   */
j = 0;					/*   	   */
while (fgets(tmp,MAXLINE,filein))	/* ⠥ । ப 䨣 */
	{
	s0 = strtok(tmp, tabspace);
	if (!stricmp(s0, "Archiver"))	/* 砫 娢 */
		{
		j = 1;
		Length[i] = 0;		/* ਧ  ।     */
		Offset[i] = 0;
		s0 = strtok(NULL, " \t;\r\n");
		Name[i] = malloc(strlen(s0));
		if (!Name[i]) exit(1);
		else strcpy(Name[i], s0);
#if DEBUG
/**/ printf ("%i \"%s\" \"%s\"", i, s0, arctype);
#endif
		if (!stricmp(s0, arctype))
		   ArcNow = i;
		else;
		continue;
		} /* "Archiver" */
	else;
	if (j && !stricmp(s0, "End"))
		{				/* 砭 娢      */
		j = 0;
		if ((i == ArcNow) && (Length[i] == 0)) ArcNow = -1; else;
		i++;
		if (i >= ARCMAX) exit(1); else;
		continue;
		} /* "End" */
	else;
	if (j)	{
		if (!stricmp(s0, Begin_Extract))	/* ᮮ⢥   */
		   s1 = strtok(NULL, tabspace);		/*  ப ய */
		else s1 = s0;
		if (!stricmp(s1, "Add"))		/* ப add        */
		   {
		   s0 = s1 + strlen(s1) + 1;		/* s0 -  砫   */
		   if ((s1 = malloc (strlen(s0) + 9
		   	+ strlen(pathname_arc)
		   	+ strlen(pathname_pkt))) == NULL) exit(1);
		   else;
		   Add[i] = s1;
		   while((s0 = strtok(NULL, tabspace)) != NULL)
/* 横 ஢ */	{
/* ப  Extract */	if (*s0 == '%')
			   {
                           s0++;
/* %a  argv[3]  */  if (*s0 == 'a') s0 = pathname_arc;
                              else
/* %f  argv[1].pkt */     if (*s0 == 'f')
					s0 = pathname_pkt;
                                    else s0--;
                           } /* if *s0 == '%' */
			else;
			strcpy (s1, s0); /* 稥 ⮪    */
			s1 += strlen(s1);
			*s1++ = ' ';
			} /* while ((s0 = strtok) != NULL) */
		   *s1 = '\0';			/*  ப */
		   continue;
		   } /* if "Add" */
		else;
		if (!stricmp(s0, "Ident"))
		   {
/* ᬥ饭 */	   if ((s0 = strtok(NULL, ",")) == NULL) continue; else;
		   Offset[i] = atol(s0);
/* 蠡 */	   if ((s1 = strtok(NULL, " \t\r\n")) == NULL) continue; else;
		   Length[i] = strlen(s1) / 2;
		   if ((s0 = malloc(Length[i] + 2)) == NULL) exit(1); else;
		   Ident[i] = s0;
/* 㥬 蠡 */   for (j = 0; j < (int)(Length[i]); j++)
			{
			*s1 = (char)toupper((int)(*s1));
/*   */	*s0 = (char)((*s1 <= '9')?(*s1 - '0')
					    :((int)(*s1) - 'A' + 10));
			*s0 <<= 4;
			s1++;
			*s1 = (char)toupper((int)(*s1));
/*   */	*s0 += ((*s1 <= '9')?(*s1 - '0')
					   :(*s1 - 'A' + 10));
			s1++;
			s0++;
			} /* for j < Length[i] */
		   j = 1;
		   continue;
		   } /* if "Ident" */
		else;
		} /* if j */
	else;
	errno = 0;	/* ⮡ ࠭  蠫 */
			/*  ᫥ 㤠 fgets  */
			/* ᯥ稫  騩 errno */
	} /* while(fgets) */
#if DEBUG
perror("After while (fgets()) errno");
#endif
if (errno) exit(1); else;
if (i == 0) exit(1); else Num_Arcs = i;
fclose(filein);

/* =============================== Reading arcmail ========================= */
filein = fopen(pathname_arc,rb);
if (arcmail_not_here || (filein == NULL))
	if (ArcNow != -1) return Add[ArcNow];
	else		  return NULL;
else;

matched = 0;
for (i = Num_Arcs - 1; i >= 0; i--)	/* 横 ॡ 娢஢ */
					/*   બ	     */
	{
	if (Length[i] == 0) continue; else; /*  ।  */
	if (Offset[i] < 0)		/*     */
	   fseek(filein,Offset[i],SEEK_END);
	else				/*   砫 䠩 */
	   fseek(filein,Offset[i],SEEK_SET);
	k = fread((void *)tmp,1,(size_t)Length[i],filein);
	if (k != (int)(Length[i]))
		{			/* ᫨ ⠫    */
		continue;		/* ஡ 㣮 .   */
		}
	else;
	matched = 1;
	for (k = 0; k < (int)(Length[i]); k++)	/* 横 ࠢ ᫥- */
						/* ⥫쭮⥩  Ident  䠩*/
	    if (tmp[k] != *(Ident[i] + k))
	    	{
	    	matched = 0;		/*  ᮢ		     */
	    	break;
	    	}
	    else;

	if (matched) break; else;	/* ᮢ		     */
	} /* for i = Num_Arcs; i-- */
fclose(filein);				/*  બ	     */
if (i >= 0) return Add[i];
else	    return NULL;
} /* Read_Compress_Cfg() */

/* ============ Restricted OutLog from Sqw-log.c ========================== */
void OutLog(char *lline)
{
char *timeline;
int i;
time_t timer[1];
#if DEBUG
/**/printf("%s\n", lline);
#endif

if (filelog == NULL) { syslog(LOG_INFO, lline); return; } else;

time(timer);
timeline = ctime (timer);
timeline[0]=' ';
timeline[1]=timeline[8];
timeline[2]=timeline[9];
for (i=8; i <= 16; i++)
    timeline[i]=timeline[i+3];
timeline[17]='\0';

if (ferror(filelog))
	{
	fputs ("Error open/write log... Rerouted to stderr", stderr);
	fclose(filelog);
	filelog = stderr;
	}
else;
fprintf (filelog, "\n!%.19sPACK %s", timeline, lline);
fprintf (stderr,  "\n!%.19sPACK %s", timeline, lline);
}

#include "./strmatch.c"
/* EOF sqwarc.c */
