/* sqwarcx.c * Content-Type: TEXT/PLAIN; charset=cp866
 * (C) 1998 Sergej Qkowlew     2:5020/122@fidonet                ࣥ 
 *
 *                       V03.00 (bugfix from V00.00 only)
 *
 * Make executable under UNIX:       cc -DUNIX -o sqwarcx sqwarcx.c 
 * Sample DOS executables building - see make_dos.bat
 *
 * Tool for unpacking inbound files   ணࠬ ᯠ 室 બ  
 * with using rules in  squish-like   ਬ ࠢ  ᪢订  䠩 
 * file compress.cfg.                 ᠭﬨ 娢஢ - compress.cfg.
 *
 * Keeps .pkt from overwriting with   ࠭ 㦥 騥 䠩 .pkt  -
 * unpacked from arcmail  files  by   १뢠 묨 ᯠ뢠묨  
 * renaming   them  temporarily  to   બ  ६ २
 * .#kt and then -  renaming  back.    .#kt  ⭮ २.
 * 
 * Unpacks files in CURRENT dir.      ᯠ뢠 䠩  ⥪ ४.
 *
 * Distribution:                      ᮡ ࠭:
 * Source code under GNU license.      室 ⥪,  ࠬ GNU.
 *
 * This  program  is free software;    ணࠬ  ᢮ -
 * you  can  redistribute it and/or   ࠭塞 ணࠬ ᯥ祭;  -
 * modify  it  under  the  terms of    ஢ /  ஢  
 * the GNU General  Public  License    ᮮ⢥⢨  ᥮騬   -
 * as published by the Free Softwa-   襭 GNU ( FSD),  ᨨ, -
 * re Foundation;  either version 2   稭  2.
 * of the  License,  or  any  later
 * version.
 *
 * This program is  distributed  in    ணࠬ ࠭  ,
 * the hope that it will be useful,      ,    -
 * but WITHOUT ANY  WARRANTY; with-    ;      ࠭⨩ ⮣,
 * out even the implied warranty of      த,    ᢮⢠
 * MERCHANTABILITY or FITNESS FOR A   ᮮ⢥ ⭮ ਬ. 
 * PARTICULAR PURPOSE. See the  GNU   ᭥ ⠫ ⠩ ᥮饥 -
 * General Public License for  more    襭 GNU.
 * details.                    (file 'copying' in this package)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include "./sqw-os.h"  /* OS-aware definitions from SQWISH sources (V02.15+) */
#include "./sqw-cfg.h"

#if (defined(__TURBOC__) || defined(DJGPP) || defined(__VC60__) || defined(__MSC60__))
#include <process.h>
#endif

#if (!defined(UNIX))
#define openlog(A,B,C)
#define syslog(A,B)
#define closelog()
#else
#include <sys/types.h>
#include <sys/wait.h>
#endif

static char Begin_Extract[] = YOUR_OS;
int	Cfg[Cfg_Verbs_Num];

#define MAXARGS 200	/* ᨬ쭮 ⢮ 㬥⮢ argv[]	    */
#define ARCMAX 40	/* ᨬ쭮 㥬 ᫮ 娢஢	    */
#define MAXLINE 4096	/* ᨬ쭠  ப 䨣 compress.cfg   */
#define LENEXT 3	/*  ७ 䠩 (᫥ ᫥ 窨)   */

static char	*compress_cfg = NULL,			/*  䨣	    */
		*rb = "rb", *at = "at";			/* ਡ fopen   */
static char	*x_pkt = "*.pkt", *x_xkt = "*.#kt";	/* renaming masks   */
static char	tabspace[] = " \t";			/*  strtok	    */

static char	*mask[] = {		/* ᪨ 䠩, ਭ  */
			"????????.mo?", /* બ 		    */
			"????????.tu?", 
			"????????.we?", 
			"????????.th?", 
			"????????.fr?", 
			"????????.sa?", 
			"????????.su?",
			NULL		/* ਧ 砭 ᯨ᪠ ᮪   */
			  };
static struct ffblk f;			/*   findfirst/next     */
					/*  ᬮ બ	    */

static int  ZeroLength = 0;		/* -z option storing		    */
static char *tossing_log = NULL;	/*    䠩 	    */
static char *InBound = "";		/*   室 䠩	    */

static FILE *filein, *filelog;		/* ਯ  fopen/...	    */
static char Buffer[MAXLINE+2],
	    Line[MAXLINE+2]; /*  ப    䠩 ଠ樨 */

/*  १ ࠡ⪨ compress.cfg ࠧ : - - - - - - - - - */
static unsigned int  Num_Arcs;		/* ᪮쪮 稫 娢஢   */
static          long Offset[ARCMAX];	/* 饭  Ident		    */
static unsigned long Length[ARCMAX];	/*  ᫥⥫쭮 ⮢  */
static unsigned char *Ident[ARCMAX];	/*  ᫥⥫쭮 ⮢   */
static unsigned char *Extract[ARCMAX];	/* ப  ᪠ 娢    */

static	char *args[MAXARGS];		/* ப  execvp/spawnvp	    */

/* =========== ⨯   㭪権 =========================== */
int strcasecmp_match(char *, char *);	/*  㭪樨 ࠢ  wildcards  */ 
void RenamePKT(char *, char *);		/* २  䠩	    */
void OutLog(char *);			/* 뢮 ப  /syslog	    */

/* ===========  ணࠬ ========================================== */
void main (int argc, char *argv[])
{
#if (defined(__TURBOC__))
short int dummy;	/* 窠 ⨢  ࡮- 2.0                */
#endif
int	matched;	/* ਧ ᮢ				    */
register int i, j;	/* 稪 直				    */
int	k;
/* - - - - - - ⢥ ᯮ塞  - - - - - - - - - - - - - - - - - */
/* ======================= Command Line help ============================== */
if (argc == 1)	{
		printf ("SqWarcx V03.00/%s (C) Sergej Qkowlew 2:5020/122\n\n", YOUR_COMPILER);

		puts ("Under GNU Public License");
		puts ("Arcmail unpacker SqWish-style with compress.cfg using. KEEPS .pkt files with");
		puts ("identical filenames from overwriting from arcmail by properly pre-renaming.\n");

		puts ("SqWitches:\n");

		puts ("-c/fido/sqwish/compress.cfg\t- config file setting");
		puts ("-n/fido/log/tossing.log\t\t- log file");
#ifdef UNIX
		puts ("(if no -n key - syslog is used)");
#endif
		printf ("-iinbound%c\t\t\t- inbound path WITH last \"%c\"\n",
				BACKSLASH, BACKSLASH);
		puts ("(current dir if no -i option)");
		puts ("-z\t\t\t\t- Ignore zero-length arcmails");

		puts ("\nErrorlevels:\n");

		puts ("0 - successfull work");
		puts ("1 - some parametres missing or wrong");
		puts ("2 - can't open or read error config file");
		puts ("3 - can't open or append log file");
		puts ("4 - No archivers defined properly in compress.cfg");
		puts ("5 - some inbound files cannot be read");
		puts ("7 - Not enough memory for some data, or too many archivers defined");
		exit (1);
		}
else
/* ======================= Command Line analysing ======================== */
   for (i = 1; i < argc; i++)
	{ char *s0 = argv[i];
	if (*s0++ == '-')
	   switch(toupper(*s0++))
		{
		case 'Z': ZeroLength = 1; break;
		case 'C': compress_cfg = s0; break;
		case 'I': InBound = s0; break;
		case 'N': tossing_log = s0; break;
		default:;
		} /* switch toupper(*s0) */
	} /* for i < argc */

if (compress_cfg == NULL) exit(2); else;
if ((filein = fopen(compress_cfg,rb)) == NULL) exit(2);else;
/* ======================= Compress.cfg analysing ======================== */
i = 0;					/*  ⥪饣 娢	   */
j = 0;					/*   	   */
while (fgets(Buffer,MAXLINE,filein))	/* ⠥ । ப 䨣 */
	{
	char *s0, *s1;
	if (!strcasecmp_match(Buffer, "Archiver*"))	/* 砫 娢 */
		{
		j = 1;
		Length[i] = 0;		/* ਧ  ।     */
		Offset[i] = 0;
		continue;
		}
	else;
	if (j && !strcasecmp_match(Buffer, "End*Archiver*"))
		{				/* 砭 娢      */
		j = 0;
		i++;
		if (i >= ARCMAX) exit(7); else;
		continue;
		}
	else;
	if (j)	{
		s1 = strtok(Buffer,tabspace);
		if (!stricmp(s1, Begin_Extract))	/* ᮮ⢥   */
		   s1 = strtok(NULL, tabspace);		/*  ப ய */
		else;
		if (!stricmp(s1, "Extract"))		/* ப extract    */
		   {
		   s0 = s1 + strlen(s1) + 1;		/* s0 -  砫   */
		   if ((s1 = malloc (strlen(s0)+7)) == NULL) exit(7);
		   else;
		   Extract[i] = s1;
		   while((s0 = strtok(NULL, tabspace)) != NULL)
/* 横 ஢ */	{
/* ப  Extract */	if (*s0 == '%')
			   {
			   s0++;
/* %a  %s%s  */  if (*s0 == 'a') s0 = "%s%s";
			   else
/* %f  *.pkt */     if (*s0 == 'f') s0 = "*.pkt";
			      else s0--;
			   } /* if *s0 == '%' */
			else;
			strcpy (s1, s0); /* 稥 ⮪    */
			s1 += strlen(s1);
			*s1++ = ' ';
			} /* while ((s0 = strtok) != NULL) */
		   *s1 = '\0';			/*  ப */
		   } /* if "Extract" */
		else;
		if (!stricmp(s1, "Ident"))
		   {
/* ᬥ饭 */	   if ((s0 = strtok(NULL, ",")) == NULL) continue; else;
		   Offset[i] = atol(s0);
/* 蠡 */	   if ((s1 = strtok(NULL, " \t\r\n")) == NULL) continue; else;
		   Length[i] = strlen(s1) / 2;
		   if ((s0 = malloc(Length[i] + 2)) == NULL) exit(7); else;
		   Ident[i] = s0;
/* 㥬 蠡 */   for (j = 0; j < (int)(Length[i]); j++)
			{
			*s1 = (char)toupper((int)(*s1));
/*   */	*s0 = (char)((*s1 <= '9')?(*s1 - '0')
					    :((int)(*s1) - 'A' + 10));
			*s0 <<= 4;
			s1++;
			*s1 = (char)toupper((int)(*s1));
/*   */	*s0 += (char)((*s1 <= '9')?(*s1 - '0')
					   :((int)(*s1) - 'A' + 10));
			s1++;
			s0++;
			} /* for j < Length[i] */
		   j = 1;
		   } /* if "Ident" */
		else;
		} /* if j */
	else;
	errno = 0;	/* ⮡ ࠭  蠫 */
			/*  ᫥ 㤠 fgets  */
			/* ᯥ稫  騩 errno */
	} /* while(fgets) */
#if DEBUG
perror("After while (fgets()) errno");
#endif
if (errno) exit(3); else;
if (i == 0) exit(4); else Num_Arcs = i;
fclose(filein);
/* ======================= Inbound files reading ========================= */
if (tossing_log) if ((filelog = fopen(tossing_log, at)) == NULL) exit(3); else;
else openlog("sqwarcx", LOG_PID | LOG_CONS, LOG_USER);

RenamePKT(x_pkt, x_xkt);		/* २ 訥 .pkt */
i = 0;
do  { /* while mask[++i] != NULL */		/* 横 ॡ ᮪  */
    sprintf (Line, "%s%s", InBound, mask[i]);
    if (!findfirst(Line, &f, 0))		/* 横 ॡ બ  */
    						/*  ⭮ ᪨	    */
     do	{
	sprintf(Line, "%s%s", InBound, f.ff_name); /*    Line    */
/* + V03.00 */
	if (ZeroLength && (f.ff_fsize == 0L))
		{
#if DEBUG
		sprintf (Buffer, "Zero-length file %s\n", Line);
		OutLog(Buffer);
#endif
		continue;		
		}
	else;
/* - V03.00 */
	filein = fopen(Line, rb);		/*   ⥭	    */
	if (filein == NULL)
		{
#if DEBUG
		sprintf (Buffer, "Can't read file %s; errno = %i; %s\n",
			Line, errno, strerror(errno));
#else
		sprintf (Buffer, "Can't read file %s; errno = %i",
			Line, errno);
#endif
		OutLog(Buffer);
		strcpy(Buffer, Line);		/*  २뢠	     */
		Buffer[strlen(Buffer) - LENEXT] = 'b';
		Buffer[strlen(Buffer) - LENEXT + 1] = (char)(i + '0');
		if (rename(Line, Buffer))
		   {
		   sprintf (Buffer, "Can't rename file %s; errno = %i",
			Line, errno);
		   OutLog(Buffer);
		   }
		else;
		continue;			/*    ⨬ 䠩      */
						/* 諨  ᫥騩	     */
		}
	else;
	matched = 0;
	for (j = Num_Arcs - 1; j >= 0; j--)	/* 横 ॡ 娢஢ */
						/*   બ	     */
		{
		if (Length[j] == 0) continue; else; /*  ।  */
		if (Offset[j] < 0)		/*     */
		   fseek(filein,Offset[j],SEEK_END);
		else				/*   砫 䠩 */
		   fseek(filein,Offset[j],SEEK_SET);
		k = fread((char *)Buffer,(size_t)1,(size_t)Length[j],filein);
		if (k != (int)(Length[j]))
			{			/* ᫨ ⠫    */
			continue;		/* ஡ 㣮 .   */
			}
		else;
		matched = 1;
		for (k = 0; k < (int)(Length[j]); k++)	/* 横 ࠢ -*/
						/* ᫥.   Ident  䠩*/
		    if (Buffer[k] != *(Ident[j] + k))
		    	{
		    	matched = 0;		/*  ᮢ		     */
		    	break;
		    	}
		    else;
		if (matched) break; else;	/* ᮢ		     */
		} /* for j = ARCMAX */
	fclose(filein);				/*  બ	     */
	if (matched)				/* ᫨  娢     */
		{				/* ନ஢ . ப  */
		RenamePKT(x_pkt, x_xkt);
		sprintf(Buffer, Extract[j], InBound, f.ff_name);
                args[0] = strtok(Buffer, tabspace);
                j = 1;
                do args[j] = strtok(NULL, tabspace);
                while (args[j++] != NULL);
#if DEBUG
/**/ printf ("%s\n", Buffer);
#endif
#ifdef UNIX
		if(fork())
			{			/* த⥫ ...    */
			wait(&k);
			k = WEXITSTATUS(k);	/* 稫       */
			}
		else	{			/* ॡ񭮪 ᯮ  */
                        execvp(args[0], args);
			exit(6);		/*  稫 ᯮ   */
			}
#else

		k = spawnvp(P_WAIT, args[0], args);
#endif
		if (k)	{
			sprintf(Buffer, "%s; ErrorLevel %i", Buffer, k);
			OutLog(Buffer);
			strcpy(Buffer, Line);	/*  २뢠	     */
			Buffer[strlen(Buffer) - LENEXT] = 'b';
			Buffer[strlen(Buffer) - LENEXT + 1] = (char)(i + '0');
			if (rename(Line, Buffer))
			   {
			   sprintf (Buffer, "Can't rename file %s; errno = %i",
				Line, errno);
			   OutLog(Buffer);
			   }
			else;
			} /* if (k) */
		else	{
			if (remove(Line))
			   {
			   sprintf (Buffer, "Can't remove %s after unpacking",
			   		Line);
			   OutLog(Buffer);
			   }
			else;
			}
		}/* if matched */
	else	{
		strcpy(Buffer, Line);
		Line[strlen(Line) - LENEXT] = 'b';
		Line[strlen(Line) - LENEXT + 1] = (char)(i + '0');
							/*  . */
		if (rename(Buffer, Line))
			sprintf(Buffer, "Can't rename %s%s to %s\n",
				InBound, f.ff_name, Line);
		else sprintf(Buffer,
			"Not-recognized archive type %s%s renamed to %s\n",
				InBound, f.ff_name, Line);
		OutLog(Buffer);
		}
	}
     while (!findnext(&f));
    else;
    }
while (mask[++i] != NULL);
RenamePKT(x_xkt, x_pkt);
if (filelog) fclose(filelog); else closelog();
exit(0);
} /* main() */

static struct ffblk f1;
static struct ffblk f2;
static char newname[20];

void RenamePKT(char *oldmask, char *newmask)
{
char *newext = newmask+2, *s0;
char cant_rename[] =  "Can't rename correctly\n";
time_t ttt;

time(&ttt);
if (!findfirst(oldmask,&f1,0))
   do	{
	strcpy(newname, f1.ff_name);
	s0 = newname;
	while (*s0 != '.') s0++; s0++;
	strcpy(s0, newext);
	while (!findfirst(newname, &f2, 0) && ++ttt)	/*   */
	   sprintf(newname,"%8.8lx.%s", (unsigned long)ttt, newext);
#if DEBUG
/**/printf ("oldname = \"%s\"; newname = \"%s\"\n", f1.ff_name, newname);
#endif
	if (ttt && !rename(f1.ff_name, newname))    /* ᯥ譮 २ */
		continue;
	else	OutLog(cant_rename);
	}
   while(!findnext(&f1));
} /* RenamePKT() */

/* ============ Restricted OutLog from Sqw-log.c ========================== */

void OutLog(char *lline)
{
char *timeline;
int i;
time_t timer[1];

if (filelog == NULL) { syslog(LOG_INFO, lline); return; } else;

time(timer);
timeline = ctime (timer);
timeline[0]=' ';
timeline[1]=timeline[8];
timeline[2]=timeline[9];
for (i=8; i <= 16; i++)
    timeline[i]=timeline[i+3];
timeline[17]='\0';

if (ferror(filelog))
	{
	fputs ("Error open/write log... Rerouted to stderr", stderr);
	fclose(filelog);
	filelog = stderr;
	}
else;
fprintf (filelog, "\n!%.19sARCX %s", timeline, lline);
}

#include "strmatch.c"

#if 0
#ifdef UNIX
/*
 * This is module for UNIX version.       ᨨ  SqWish   UNIX.
 * There is definition of DOS func-        ।   ᪨   㭪樨
 * tions  findfirst/findnext  under   findfirst/findnext  UNIX.
 * UNIX.
 *
 * Copyright (C) 1997 Ivan Munitsin, 2:5020/418                     㭨
 */

#include <unistd.h>

int findfirst(const char *pathname, struct ffblk *ffblk, int attrib) {
char *pos;
struct stat buf;
char findpath[NAME_MAX];

   strcpy(findpath, pathname);
   if ((pos=(char *)strrchr(findpath, '/'))==NULL) {
      strcpy(ffblk->fname, findpath);
      strcpy(findpath, ".");
   }
   else {
      strcpy(ffblk->fname, pos+1);
      *pos='\0';
   }

   ffblk->dir=opendir(findpath);
   while ((ffblk->entry=readdir(ffblk->dir))!=NULL) {
      if (strcasecmp_match(ffblk->entry->d_name, ffblk->fname) == 0) {
         ffblk->ff_name=ffblk->entry->d_name;
	 stat(ffblk->ff_name, &buf);
	 ffblk->ff_fsize=buf.st_size;
         return 0;
      }
   }
   closedir(ffblk->dir);
   return -1;
}

int findnext(struct ffblk *ffblk) {
struct stat buf;

   while ((ffblk->entry=readdir(ffblk->dir))!=NULL) {
      if (strcasecmp_match(ffblk->entry->d_name, ffblk->fname) == 0) {
         ffblk->ff_name=ffblk->entry->d_name;
	 stat(ffblk->ff_name, &buf);
	 ffblk->ff_fsize=buf.st_size;
         return 0;
      }
   }
   closedir(ffblk->dir);
   return -1;
}
#endif
#endif
/* EOF sqwarcx.c */
